Freeciv-3.1: /fast/freeciv/nightly/S3_1/common/rgbcolor.c File Reference

Freeciv-3.1

Loading...
Searching...
No Matches
Functions
rgbcolor.c File Reference
`#include <stdarg.h>`
`#include "fcintl.h"`
`#include "log.h"`
`#include "registry.h"`
`#include "fc_interface.h"`
`#include "game.h"`
`#include "rgbcolor.h"`

Go to the source code of this file.

## Functions

struct rgbcolor * | rgbcolor_new (int r, int g, int b)
struct rgbcolor * | rgbcolor_copy (const struct rgbcolor *prgbcolor)
bool | rgbcolors_are_equal (const struct rgbcolor *c1, const struct rgbcolor *c2)
void | rgbcolor_destroy (struct rgbcolor *prgbcolor)
bool | rgbcolor_load (struct section_file *file, struct rgbcolor **prgbcolor, char *path,...)
void | rgbcolor_save (struct section_file *file, const struct rgbcolor *prgbcolor, char *path,...)
bool | rgbcolor_to_hex (const struct rgbcolor *prgbcolor, char *hex, size_t hex_len)
bool | rgbcolor_from_hex (struct rgbcolor **prgbcolor, const char *hex)
int | rgbcolor_brightness_score (struct rgbcolor *prgbcolor)

## Function Documentation

## ◆ rgbcolor_brightness_score()

int rgbcolor_brightness_score | ( | struct rgbcolor * | prgbcolor | ) |

Return a number indicating the perceptual brightness of this color relative to others (larger is brighter).

Definition at line 196 of file rgbcolor.c.

Referenced by color_brightness_score().

## ◆ rgbcolor_copy()

struct rgbcolor * rgbcolor_copy | ( | const struct rgbcolor * | prgbcolor | ) |

Allocate new rgbcolor structure and make it copy of one given as input. Return new one.

Definition at line 51 of file rgbcolor.c.

Referenced by player_set_color().

## ◆ rgbcolor_destroy()

void rgbcolor_destroy | ( | struct rgbcolor * | prgbcolor | ) |

Free rgbcolor structure.

Definition at line 74 of file rgbcolor.c.

Referenced by color_brightness_score(), color_system_free(), game_ruleset_free(), handle_player_info(), nation_free(), player_destroy(), player_set_color(), playercolor_command(), playercolor_free(), server_player_set_color(), sg_load_players_basic(), sg_load_players_basic(), and terrains_free().

## ◆ rgbcolor_from_hex()

bool rgbcolor_from_hex | ( | struct rgbcolor ** | prgbcolor,
|  | const char * | hex
| ) |  |

Convert a hex string into a rgb color

Definition at line 162 of file rgbcolor.c.

Referenced by playercolor_command().

## ◆ rgbcolor_load()

bool rgbcolor_load | ( | struct section_file * | file,
|  | struct rgbcolor ** | prgbcolor,
|  | char * | path,
|  |  | ...
| ) |  |

Lookup an RGB color definition ([colorpath].red, [colorpath].green and [colorpath].blue). Returns TRUE on success and FALSE on error.

Definition at line 90 of file rgbcolor.c.

Referenced by color_system_read(), load_ruleset_game(), load_ruleset_nations(), load_ruleset_terrain(), sg_load_players_basic(), and sg_load_players_basic().

## ◆ rgbcolor_new()

struct rgbcolor * rgbcolor_new | ( | int | r,
|  | int | g,
|  | int | b
| ) |  |

Allocate new rgbcolor structure.

Definition at line 34 of file rgbcolor.c.

Referenced by color_brightness_score(), color_system_read(), handle_player_info(), handle_ruleset_game(), handle_ruleset_terrain(), rgbcolor_copy(), rgbcolor_from_hex(), and rgbcolor_load().

## ◆ rgbcolor_save()

void rgbcolor_save | ( | struct section_file * | file,
|  | const struct rgbcolor * | prgbcolor,
|  | char * | path,
|  |  | ...
| ) |  |

Save an RGB color definition ([colorpath].red, [colorpath].green and [colorpath].blue).

Definition at line 121 of file rgbcolor.c.

Referenced by save_game_ruleset(), save_nation(), save_terrain_ruleset(), and sg_save_player_main().

## ◆ rgbcolor_to_hex()

bool rgbcolor_to_hex | ( | const struct rgbcolor * | prgbcolor,
|  | char * | hex,
|  | size_t | hex_len
| ) |  |

Convert a rgb color to a hex string (like 0xff0000 for red [255, 0, 0]).

Definition at line 142 of file rgbcolor.c.

Referenced by player_color_ftstr().

## ◆ rgbcolors_are_equal()

bool rgbcolors_are_equal | ( | const struct rgbcolor * | c1,
|  | const struct rgbcolor * | c2
| ) |  |

Test whether two rgbcolor structures represent the exact same color value. (Does not attempt to determine whether they are visually distinguishable.)

Definition at line 62 of file rgbcolor.c.

Referenced by assign_player_colors(), and playercolor_command().